var start_text = "The Three Islands...\n\n\nTheir history composed of the ballads of battle and war.\n\nFor hundreds of years its people have fought side by side and against each other.\n\nA fully united kingdom has been the hope of many lords, princes, and kings, but no one has fully succeeded.\n\nHowever, new weapons of war are coming to set the field of battle ablaze.\n\n\nBeasts too terrifying to believe... and soldiers just as ruthless...\n\n\n\n\nWith these weapons, one faction shall finally prevail...";


function Intro()
{
	var bgc = CreateColor(0,94,138,255);
	var lasttime = GetTime();
	ml_pressed = true;

	while(AreKeysLeft())
		GetKey();
		
	DrawMap();
	Rectangle(0,0,320,240, bgc);
	DrawMap(undefined,undefined,undefined,undefined,true);
	
	var top = GrabImage(0,0,320,16)
	var bot = GrabImage(0,240-16-1,320,17)
	var images1 = new Array(16);
	var images2 = new Array(16);
	for (i=0;i<16;i++)
	{
		images1[i] = GrabImage(0,16+i,320,1);
		images2[i] = GrabImage(0,240-16-i-1,320,1);
	}
	
	var colours = new Array(16);
	for (i=0;i<16;i++)
	{
		colours[i] = CreateColor(255,255,255,i*255/16);
	}

	var frames = 0;
	var the_string = start_text;
	var scroll_max = -1*font.getStringHeight(the_string, 160);
	var scroll_begin = 220-8;
	var scroll = scroll_begin;

	var fade = 0;
	var fade_max = 64;

	var fadein = 0;
	
	while(true)
	{
		Rectangle(0,0,320,240, bgc);
		DrawMap(undefined,undefined,undefined,undefined,true);
		
		font.drawTextBox(2,2+12+scroll,160,220,0, the_string);

		top.blit(0,0);
		bot.blit(0,240-17);

		for (i=0;i<16;i++)
		{
			images1[i].blitMask(0,16+i,colours[15-i]);
			images2[i].blitMask(0,240-16-i-1,colours[15-i]);
		}

	  if (scroll>scroll_max)
			frames++;
		if (frames%2==0)
		{
		  scroll--;
		  if (scroll<scroll_max)
		    fade++
		}
		if (fade > 0)
			fade++;
		
		if (!IsMouseButtonPressed(MOUSE_LEFT))
			ml_pressed = false;
		
		if (IsMouseButtonPressed(MOUSE_LEFT) && ml_pressed == false)
		{
			ml_pressed = true;
			fade++;
			break;
		}
		
		if (scroll> scroll_max)
		{
		
			while(AreKeysLeft())
			{
				if (fade == 0)
					fade = 1;
				GetKey();
			}
		}

		if (fadein <fade_max)
		{
			Rectangle(0,0,320,240,CreateColor(0,0,0,255-(fadein)*255/64));
			fadein++;
		}

		if (fade > 0)
		{
			Rectangle(0,0,320,240,CreateColor(0,0,0,(fade)*255/64));
			if (fade > 64)
				return;
		}
		FlipScreen();
		while(GetTime()-lasttime<1000/30);
		lasttime=GetTime();
	}
}

function ShowEnding()
{
	FadeOverOut();

	var alcount = 0;

	for (s=0;s<max_factions;s++)
	{
		factions[s].num_areas = 0;
	}
	for (s=0;s<num_areas;s++)
	{
		if (areas[s].owner >-1)
			factions[areas[s].owner].num_areas++;
	}
	
	for (s=0;s<max_factions;s++)
	{
		if (s!=g_player)
		{
			if (factions[g_player].allied[s] == 1 && factions[s].num_areas>0)
				alcount++;
			else if (factions[s].num_areas>0)
				return;//you didn't win yet :S
		}
	}

	var stringy = "";

	if (alcount == 0)
		stringy = "  With the victory of the "+factions[g_player].name+" faction, the three islands can now finally prosper in peace."  
	else
		stringy = "  With the victory of the "+factions[g_player].name+" faction and her allies, the three islands can now finally prosper in peace."  

	if (g_round <16)
		stringy = stringy+"\n\n  The conquest was short and quick, and those that had thought of resisting now support "+factions[g_player].leader+" in "+factions[g_player].his+" rule."
	else if (g_round <32)
		stringy = stringy+"\n\n  The conquest was drawn out, but those that once resisted now support "+factions[g_player].leader+" in "+factions[g_player].his+" rule."
	else 
		stringy = stringy+"\n\n  The conquest was long and seemingly endless, but those that bitterly resisted now support "+factions[g_player].leader+" in "+factions[g_player].his+" rule."

	stringy = stringy+"\n\n  Because of the success of the new beasts in battle there has finally been headway for a conquest onto the mainland.  With the fall the "+factions[5].name+", it is not the beginning of a united country...\n\n\n  ...It is the beginning of an empire.";

	var bgc = CreateColor(0,94,138,255);
	var lasttime = GetTime();
	ml_pressed = true;


	DrawMap();
	Rectangle(0,0,320,240, bgc);
	DrawMap();
	
	var top = GrabImage(0,0,320,16)
	var bot = GrabImage(0,240-16-1,320,17)
	var images1 = new Array(16);
	var images2 = new Array(16);
	for (i=0;i<16;i++)
	{
		images1[i] = GrabImage(0,16+i,320,1);
		images2[i] = GrabImage(0,240-16-i-1,320,1);
	}
	
	var colours = new Array(16);
	for (i=0;i<16;i++)
	{
		colours[i] = CreateColor(255,255,255,i*255/16);
	}

	var frames = 0;
	var the_string = stringy;
	var scroll_max = -1*font.getStringHeight(the_string, 160);
	var scroll_begin = 220-8;
	var scroll = scroll_begin;

	var fade = 0;
	var fade_max = 64;

	var fadein = 0;
	
	PlayMusic(3);


	while(true)
	{
		Rectangle(0,0,320,240, bgc);
		DrawMap();
		
		font.drawTextBox(2,2+12+scroll,160,220,0, the_string);

		top.blit(0,0);
		bot.blit(0,240-17);

		for (i=0;i<16;i++)
		{
			images1[i].blitMask(0,16+i,colours[15-i]);
			images2[i].blitMask(0,240-16-i-1,colours[15-i]);
		}

	  if (scroll>scroll_max)
			frames++;
		if (frames%3==0)
		{
		  scroll--;
		  if (scroll<scroll_max)
		    fade++
		}
		if (fade > 0)
			fade++;
		
		if (!IsMouseButtonPressed(MOUSE_LEFT))
			ml_pressed = false;
		
		if (IsMouseButtonPressed(MOUSE_LEFT) && ml_pressed == false && fade == 0)
		{
			ml_pressed = true;
			fade++;
		}
		
		if (scroll> scroll_max)
		{
		
			while(AreKeysLeft())
			{
				if (fade == 0)
					fade = 1;
				GetKey();
			}
		}

		if (fadein <fade_max)
		{
			Rectangle(0,0,320,240,CreateColor(0,0,0,255-(fadein)*255/64));
			fadein++;
		}

		if (fade > 0)
		{
			Rectangle(0,0,320,240,CreateColor(0,0,0,(fade)*255/64));
			if (fade > 64)
			{
				ShowEnding2();
				return;
			}
		}
		FlipScreen();
		while(GetTime()-lasttime<1000/30);
		lasttime=GetTime();
	}

}

function ShowEnding2()
{
	//ending pic
	var the_end = LoadImage("end1.png");
	var the = LoadImage("end2.png");
	var end = LoadImage("end3.png");
	
	var ex = 160-the_end.width/2;
	var ey = 120-the_end.height/2;
	
	var lasttime = GetTime();

	var thud = LoadSound("thud1.wav");
	
	for (s=64;s>=0;s--)
	{
		the.blit(ex-(s/2)*(s/2)*2,ey);
		end.blit(ex+(s/2)*(s/2)*2,ey);
	
		while(GetTime()-lasttime < 1000/30);
		lasttime = GetTime();
		FlipScreen();
	}
	thud.stop();
	thud.setPosition(0);
	thud.play(false);

	fade = 0;
	fade_max = 128;

	ml_pressed = true;

	while(true)
	{
		the_end.blit(ex,ey);
		while(GetTime()-lasttime < 1000/30);
		lasttime = GetTime();

		if (fade > 0)
		{
			Rectangle(0,0,320,240, CreateColor(0,0,0,fade*255/fade_max));
			fade++;
			FadeMusic(fade/fade_max);
		}
		else
		{
			while(AreKeysLeft())
			{
				fade = 1;
				GetKey();
			}
			
			if (!IsMouseButtonPressed(MOUSE_LEFT))
			{
				ml_pressed = false;
			}
			if (IsMouseButtonPressed(MOUSE_LEFT) && ml_pressed == false)
			{
				ml_pressed = true;
				fade=1;
			}
		}

		FlipScreen();
		if (fade > fade_max)
		{
			RestartGame();
			return;
		}
	}

}

function ShowGameOver()
{
	PromptOverDisplay(undefined, undefined, "Game Over");
	FadeOverOut();
	RestartGame();
}